//+------------------------------------------------------------------+
//|                                                      TSrv2.0.mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
#define MAGICMA  00123456789

extern int StopLoss = 1000;
extern int TakeProfit = 150;
extern double LotSize = 1;
extern double MovingAvgOscillatorLimit = 20;

int CheckIndicatorForOpen()   {
   int trade_direction = 0;
   int shiftHighest = iHighest(NULL,0,MODE_HIGH,100,1);
   int shiftLowest = iLowest(NULL,0,MODE_LOW,100,1);
   double resistance  = High[shiftHighest];
   double support = Low[shiftLowest];
   datetime t_high = iTime(NULL,0,shiftHighest);
   datetime t_low = iTime(NULL,0,shiftLowest);
   double hist1 = iOsMA(NULL,0,12,26,9,PRICE_CLOSE,1);
   double hist2 = iOsMA(NULL,0,12,26,9,PRICE_CLOSE,2);
      
   if (hist1 > MovingAvgOscillatorLimit  && hist2 < MovingAvgOscillatorLimit  && hist1 > 0 && hist2 > 0)
      {
      if (Ask > resistance)
         trade_direction = 1;
      }
   else if (hist1 < (-MovingAvgOscillatorLimit)  && hist2 > (-MovingAvgOscillatorLimit)&& hist1 < 0 && hist2 < 0)
      {
      if (Bid < support)
         trade_direction = 2;
      }      
   return(trade_direction);
}
 
void CheckForOpen()  {
   int res;
   double stoplossL,takeprofitL;
   if(CheckIndicatorForOpen() == 1) {
      if (StopLoss > 0)
         stoplossL = Ask-StopLoss*Point;
      if (TakeProfit > 0)
         takeprofitL = Ask+TakeProfit*Point;
      res=OrderSend(Symbol(),OP_BUY,LotSize,Ask,3,stoplossL,takeprofitL,"",MAGICMA,0,Blue);
      return;
     }
   if(CheckIndicatorForOpen() == 2) {
      if (StopLoss > 0)
         stoplossL = Bid+StopLoss*Point;
      if (TakeProfit > 0)
         takeprofitL = Bid-TakeProfit*Point;
      res=OrderSend(Symbol(),OP_SELL,LotSize,Bid,3,stoplossL,takeprofitL,"",MAGICMA,0,Red);  
      return;
     }
   }  

int CalculateCurrentOrders(string symbol) {
   int buys=0,sells=0;
   for(int i=0;i<OrdersTotal();i++) {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICMA) {
         if(OrderType()==OP_BUY)  buys++;
         if(OrderType()==OP_SELL) sells++;
        }
     }
   if(buys>0) return(buys);
   else       return(-sells);
  }    

int start() {
   Comment("Mov avg " + MovingAvgOscillatorLimit);
   if(Bars<100 || IsTradeAllowed()==false) return;
   if(CalculateCurrentOrders(Symbol())==0) 
      CheckForOpen();
   return(0);
  }
 

int init()
  {
   MovingAvgOscillatorLimit = MovingAvgOscillatorLimit * Point;
   return(0);
  }

